#!/usr/bin/perl -w

$filename = $ARGV[0];


open(CONFIG, "$filename");
sysread CONFIG, $config_file, 16211;
close(CONFIG);
my (@CONFIG) = split('', $config_file);
my $size = @CONFIG;
print "Config file is $size, yay.\n";



my ($one_good, $one_checksum) = compare_checksum(0x611, 0x592, 0x610);
print "ONE: $one_good $one_checksum\n";

my($two_good, $two_checksum) = compare_checksum(0x691, 0x612, 0x690);
print "TWO: $two_good $two_checksum\n";

my($three_good, $three_checksum) = compare_checksum(0x3f52, 0x0000, 0x3f51);
print "THREE: $three_good $three_checksum\n";




sub compare_checksum {
	my ($location, $low, $high) = @_;
	my $checksum = ord($CONFIG[$location]);
	my $total = 0;
	my $mod_total = 0;


	for (my $i = $low ; $i <= $high ; $i++) {
		$total += ord($CONFIG[$i]);
	}
	$mod_total = $total % 256;

	my $good = 0;
	if ($checksum == $mod_total) {
		$good = 1;
	}

	return ($good, $checksum);
}


	


