#!/usr/bin/perl -w

use strict;
use Device::SerialPort;


my $port = new Device::SerialPort("/dev/tty.usbserial0");
$port->parity("none");
$port->databits(8);
$port->stopbits(1);
$port->handshake("none");
$port->baudrate(19200);
$port->read_const_time(500);       # 500 milliseconds = 0.5 seconds
$port->read_char_time(5);          # avg time between read char

my $first_packet = 10;
my $second_packet = 8;
my $third_packet = 16193;

my $char_per_read = 255;

my $count;
print "Hit enter, then hit BAND on the VX-7.\n";
my $woo = <STDIN>;
sleep 2;

my $init = '';
until (length($init) >= $first_packet) {
	 $init = $port->read($char_per_read);
	 print ++$count . ": count (initial) captured: " . length($init) . "\n";
	 if (length($init) < $first_packet && length($init) > 0) {
		 print "crap!  Buffer underrun, please hit BAND again.\n";
		 $init = '';
	 }
}

print "Initial block recieved. Size: " . length($init) . " byte(s)\n";

sleep 1;
$port->write("\x06");
sleep 2;

my $scnd = '';
until (length($scnd) >= $second_packet) {
	$scnd = $port->read($char_per_read);
	print ++$count . ": count (second) captured: " . length($scnd) . "\n";
}

print "Second block recieved. Size: " . length($scnd) . " byte(s)\n";
if (length($scnd) > $second_packet) {
	print "Packet too big, truncating first byte (likely serial echo)\n";
	($scnd) =~ s/^.//;
}


sleep 1;
$port->write("\x06");
sleep 3;

my $finl = '';
until (length($finl) >= $third_packet) {
	$finl .= $port->read($char_per_read);
	print ++$count . ": count (main) captured: " . length($finl) . "\n";
}
print "Main block recieved. Size: " . length($finl) . " byte(s)\n";
if (length($finl) > $third_packet) {
	print "Packet too big, truncating first byte (serial echo again)\n";
	($finl) =~ s/^.//;
}

my $whole = $init . $scnd . $finl;
open(OUT, ">file.vx7");
select(OUT);
$|++;
print $whole;
close(OUT);
select(STDOUT);







